$waterColor: #75b2af;
$woolColor: #93ad72;
$woodColor: #688e65;
$oreColor: #5b7e7e;
$brickColor: #cc6b4b;
$grainColor: #efcb5f;
$desertColor: #dbd1a5;

$hexSize: 2;

$hexWidth: 3.9em * $hexSize;
$hexHeight: 4.4em;

.hex-grid {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);

    .hex-row {
        height: 3.7em * $hexSize;
        display: flex;
        justify-content: center;

        .hex {
            width: $hexWidth;
            height: $hexHeight;
            position: relative;
            float: left;
            margin-right: 0.2em * $hexSize;
            margin-left: 0.2em * $hexSize;
            display: flex;
            justify-content: center;

            .background {
                position: absolute;
                top: 50%;
                left: 50%;
                z-index: 999;
                width: $hexWidth;
                height: $hexWidth;
                transform: translate(-50%, -50%);
                background-size: cover;

                &.background-wool {
                    background-image: url("/images/wool.svg");
                }

                &.background-brick {
                    background-image: url("/images/brick.svg");
                }

                &.background-ore {
                    background-image: url("/images/ore.svg");
                }

                &.background-grain {
                    background-image: url("/images/grain.svg");
                }

                &.background-wood {
                    background-image: url("/images/wood.svg");
                }

                &.background-question {
                    background-image: url("/images/question.svg");
                }
            }

            .port-direction-background {
                position: absolute;
                top: 50%;
                left: 50%;
                z-index: 998;
                width: 130px;
                height: 130px;
                transform: translate(-50%,-50%);
                background-size: cover;
                background-image: url("/images/port.png");

                &.direction-nw {
                    transform-origin: center;
                    -webkit-transform: translate(-50%,-50%) rotate(120deg);
                    transform: translate(-50%,-50%) rotate(120deg);
                }

                &.direction-ne {
                    transform-origin: center;
                    -webkit-transform: translate(-50%,-50%) rotate(180deg);
                    transform: translate(-50%,-50%) rotate(180deg);
                }

                &.direction-e {
                    transform-origin: center;
                    -webkit-transform: translate(-50%,-50%) rotate(240deg);
                    transform: translate(-50%,-50%) rotate(240deg);
                }

                &.direction-se {
                    transform-origin: center;
                    -webkit-transform: translate(-50%,-50%) rotate(300deg);
                    transform: translate(-50%,-50%) rotate(300deg);
                }

                &.direction-w {
                    transform-origin: center;
                    -webkit-transform: translate(-50%,-50%) rotate(60deg);
                    transform: translate(-50%,-50%) rotate(60deg);
                }
            }


            .port-background {
                position: absolute;
                top: 30%;
                left: 50%;
                z-index: 999;
                width: 40px;
                height: 40px;
                transform: translate(-50%,-50%);
            }

            .port {
                z-index: 999;
                color: #ffffff;
                position: absolute;
                top: 65%;
            }

            &:before, &:after {
                content: '';
                position: absolute;
                width: 100%;
                border-left: $hexHeight - 0.5em solid transparent;
                border-right: $hexHeight - 0.5em solid transparent;
                border-bottom-width: 1.15em * $hexSize;
                border-bottom-style: solid;
                border-bottom-color: transparent;
                border-top-width: 1.15em * $hexSize;
                border-top-style: solid;
                border-top-color: transparent;
            }

            &:before {
                bottom: $hexHeight;
            }

            &:after {
                top: $hexHeight;
            }

            &.water {
                background: $waterColor;

                &:before {
                    border-bottom-color: $waterColor;
                }

                &:after {
                    border-top-color: $waterColor;
                }
            }

            &.wool {
                background: $woolColor;

                &:before {
                    border-bottom-color: $woolColor;
                }

                &:after {
                    border-top-color: $woolColor;
                }
            }

            &.ore {
                background: $oreColor;

                &:before {
                    border-bottom-color: $oreColor;
                }

                &:after {
                    border-top-color: $oreColor;
                }
            }

            &.wood {
                background: $woodColor;

                &:before {
                    border-bottom-color: $woodColor;
                }

                &:after {
                    border-top-color: $woodColor;
                }
            }

            &.brick {
                background: $brickColor;

                &:before {
                    border-bottom-color: $brickColor;
                }

                &:after {
                    border-top-color: $brickColor;
                }
            }

            &.grain {
                background: $grainColor;

                &:before {
                    border-bottom-color: $grainColor;
                }

                &:after {
                    border-top-color: $grainColor;
                }
            }

            &.desert {
                background: $desertColor;

                &:before {
                    border-bottom-color: $desertColor;
                }

                &:after {
                    border-top-color: $desertColor;
                }
            }

            .star {
                margin: 16em * $hexSize;
            }

            .pole {
                position: absolute;
                border-radius: 50%;
                background-color: sandybrown;
                color: black;
                width: 1.5em * $hexSize;
                height: 1.5em * $hexSize;
                line-height: 1.5em * $hexSize;
                text-align: center;
                z-index: 99999;
                opacity: 0;
                transition: opacity 0.3s ease-in-out;
                box-shadow: 5px 5px 5px rgba(0, 0, 0, 0.25);

                &:hover {
                    cursor: pointer;
                    opacity: 1;
                }

                &.north-pole {
                    top: -2.0em * $hexSize;
                    left: 1.2em * $hexSize;
                }

                &.south-pole {
                    bottom: -1.8em * $hexSize;
                    left: 1.2em * $hexSize;
                }

                &.visible {
                    opacity: 1;
                }

                &.top3 {
                    opacity: 1;
                    background-color: #c65320;
                    font-weight: bold;
                    color: white;
                }

                &.village {
                    opacity: 1;
                    background-color: transparent;
                    background-image: url("/images/Village.svg");
                    box-shadow: none;
                    width: 2.3em * $hexSize;
                    height: 2.3em * $hexSize;
                    line-height: 1.8em * $hexSize;
                    padding-top: 10%;
                    font-weight: normal;
                    color: black;
                    -webkit-filter: drop-shadow(5px 5px 5px rgba(0,0,0,0.25));
                    filter: drop-shadow(5px 5px 5px rgba(0,0,0,0.25));

                    &.north-pole {
                        top: -2.6em * $hexSize;
                        left: 0.8em * $hexSize;
                    }

                    &.south-pole {
                        bottom: -2em * $hexSize;
                        left: 0.8em * $hexSize;
                    }
                }
            }

            .fiche {
                position: absolute;
                top: 50%;
                left: 50%;
                width: 2em * $hexSize;
                height: 2em * $hexSize;
                background-color: #ffea85;
                border-radius: 100%;
                border: (2px * $hexSize) solid white;
                transform: translate(-50%, -50%);
                z-index: 999;
                opacity: 0;
                transition: opacity 0.1s ease-in;

                &.visible {
                    opacity: 1;
                }

                .number {
                    position: absolute;
                    top: 0.3em * $hexSize;
                    left: 0;
                    width: 100%;
                    text-align: center;
                    font-size: 7px * $hexSize;
                }

                .stars {
                    position: absolute;
                    bottom: .2em * $hexSize;
                    left: 0;
                    font-size: 7px * $hexSize;
                    width: 100%;
                    text-align: center;
                }
            }
        }
    }
}
